<?php
/*
ingest.php 13/Nov/2013
An add-in for Airtime 2.5
John Chewter info@coastal-computing.com

This file is part of a 3 file solution.
1/ ingest.php and progressclass.php should be placed in a NEW folder called: /usr/share/airtime/public/ingest/
2/ index.phtml is a replacement for /usr/share/airtime/application/views/scripts/plupload/index.phtml
MAKE A BACKUP COPY FIRST!!!!!!
*/
$ingestversion = '0.4 Beta';
include('progressclass.php');
$prog = new ProgressBar(); 
	
// Security Cookie Check - set in Airtime 2.5 to stop direct access to this file.
$ingest=$_COOKIE['ingest'];
if ($ingest<>'300751') {
	echo 'This page cannot be viewed directly';
	die;
}

// File size in kilobytes (1024KB is 1MB). For unlimited use 0. Example $sizelimit = 25;
$sizelimit = 0;

// Get the Aitime STOR/organize path From URL
$absolute_path_to_storfolder = 'Cannot Get STOR PATH';
if (isset($_GET['stor'])){ 
	$absolute_path_to_storfolder = rtrim($_GET['stor'],'/');
}

//Simple function to check that the remote file, to be imported, actually exists.
function curl_exists($myurl){
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL,$myurl);
    // don't download content
    curl_setopt($ch, CURLOPT_NOBODY, 1);
    curl_setopt($ch, CURLOPT_FAILONERROR, 1);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    if(curl_exec($ch)!==FALSE){ return true; } else { return false; }
}
function progressCallback( $download_size, $downloaded_size, $upload_size, $uploaded_size )
{
	global $prog;
	global $uploadfile;
	static $previousProgress = 0;
	if ( $download_size == 0 )
	{
	 	$progress = 0;
	}
	else
	{
		$progress = round( $downloaded_size * 100 / $download_size );
		if ( $progress > $previousProgress)
		{
			$showprogress = $progress;
			if ($showprogress >= 100) 
			{
				$showprogress = 100;
				$prog->ProgressBar(false);
			}
			$prog->progress("", $showprogress, 100,100);
			$previousProgress = $progress;
		}				
	}
}

// *** Start Header ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Remote File Importer - <?php echo $ingestversion; ?></title>

<style type="text/css">
.btn{
  display: inline-block;
  padding-top: 4px;
  padding-right: 14px;
  padding-bottom: 4px;
  padding-left: 14px;
  margin-bottom: 0px;
  font-size: 14px;
  line-height: 20px;
  text-align: center;
  vertical-align: middle;
  cursor: pointer;
  color: #ffffff;
  text-shadow: 0px -1px 0px rgba(0, 0, 0, 0.25);
  background-color: #676767;
  background-image: #676767;
  background-repeat: repeat-x;
  border-top-width: 1px;
  border-right-width-value: 1px;
  border-bottom-width: 1px;
  border-left-width-value: 1px;
  border-top-style: solid;
  border-right-style-value: solid;
  border-bottom-style: solid;
  border-left-style-value: solid;
  border-top-color: #5b5b5b;
  border-right-color-value: #5b5b5b;
  border-left-color-value: #5b5b5b;
  border-image-source: none;
  border-image-slice: 100% 100% 100% 100%;
  border-image-width: 1 1 1 1;
  border-image-outset: 0 0 0 0;
  border-image-repeat: stretch stretch;
  border-bottom-color: #4f4f4f;
  border-top-left-radius: 1px;
  border-top-right-radius: 1px;
  border-bottom-right-radius: 1px;
  border-bottom-left-radius: 1px;
  box-shadow: 0px 1px 0px rgba(255, 255, 255, 0.2) inset, 0px 1px 2px rgba(0, 0, 0, 0.05);
}
</style>
</head>
<?php
// *** End  Header
?>
<body style="font-family:Verdana, Arial, Helvetica, sans-serif; font-size:11px; background-color:#dfdfdf; color:#42454a;">
<?php
// Initialize Variables
$error = false;
$copy_fail = false;
$submit = false;
$file_size='';

// Check path to Airtime stor/organize exists. If not - exit with message.
if (file_exists($absolute_path_to_storfolder)) {

// *** Start of simple display form to get remote file URL from user. 
$self = $_SERVER['PHP_SELF'];
if (!isset($_GET['fs'])){
	if (isset($_GET['file'])){
		$file = rawurldecode($_GET['file']);
	}
	if (isset($_GET['namenew'])){
		$namenew = rawurldecode($_GET['namenew']);
	} else {
		$namenew='*';
	}
	echo '<form method="GET" action="'.$self.'">';
	echo '<table width="100%">';
	echo '<tr><td width="30%">Full Url To File For Import.</td><td><input type="text" name="file" id="file" size="60" value="'.$file.'"></td></tr>';
	echo '<tr><td width="30%">New file name (Optional).</td><td><input type="text" name="namenew" id="namenew" size="60" value="'.$namenew.'"></td></tr>';
	echo '<table>';
	echo '<input type="hidden" name="stor" id="stor" size="60" value="'. $absolute_path_to_storfolder . '">';
	echo '<input name="submit" type="submit" id="submit" value="Import" accesskey="s" class="btn"></p>';
	echo '</fieldset></form>';
}
// *** End of simple display form to get remote file URL from user.  
?><?php
// Has the form been submitted?
if (isset($_GET['submit'])){ $submit = true; }
if (isset($_GET['ds'])){ $ds = $_GET['ds']; }

// Get the file size transferred progress
if (isset($_GET['fs']))
{
	$file_size = $_GET['fs'];
	$ds_fs = filesize($ds);
	$progress = round(($ds_fs/$file_size)*100, 2);

	if($progress >= 100) { $done = 1; }	else { $done = 0;}
} 
elseif ($submit == true)
{
	chdir($absolute_path_to_storfolder);
	
	$sizelimit_kb = $sizelimit;
	$sizelimit = $sizelimit * 1024;
 	$file = rawurldecode($_GET['file']);
	$uploadfile = explode('/', $file);
	$filename = array_pop($uploadfile);
	$newfilename = $_GET['namenew'];

	// Get the file name and rename it upon import, if required.
	if ($newfilename==''){ $newfilename='*'; }
	$newfilename = str_replace('*', $filename, $newfilename);
	if (!$newfilename){ $newfilename = $filename; }
	
	// Check remote file actually exists.
	if (curl_exists($file)){
	}else{
		echo '<p><strong><span style="color:#ff0000;">Invalid File URL! ' . $file . '</span></strong></p>';
		$error = true;
	}
	
	// Check for no remote URL entered
	if ($file == '')
	{
		echo '<p><strong><span style="color:#ff0000;">Please enter a URL to retrieve file from!</span></strong></p>';
		$error = true;
	}
	 
	if ($error == false)
	{
		// OK - The initial tests were passed.
		// Remove any trailing slashes in the STOR path.
		$dest = rtrim($absolute_path_to_storfolder, '/');
		$ds = array($dest, '/', $newfilename);
		$ds = implode('', $ds);
		$newname_count = 0;
		
		// *** Start - Duplicate file name test
		if (file_exists($ds))
		{
			// A file of the same name exists - so we need to rename the new file
			$new_name_needed = true; 
			$newname_count++;
			$newfile = array($newname_count, $newfilename);
			$newfile = implode('~', $newfile);
			$newfile_ds = array($dest, '/', $newfile);
			$newfile_ds = implode('', $newfile_ds);
			$renamed = false;
			while($renamed == false)
			{
				if (file_exists($newfile_ds))
				{
					$newname_count++;
					$newfile = array($newname_count, $newfilename);
					$newfile = implode('~', $newfile);
					$newfile_ds = array($dest, '/', $newfile);
					$newfile_ds = implode('', $newfile_ds);
				}
				else
				{
					$renamed = true;
				}
			}
			$newfilename = $newfile;
			$ds = $newfile_ds;
			echo '<p><strong>The file already existed, so, the new saved file name is '.$newfile.'</strong></p>';
		}
		// *** End - Duplicate file name test
		
		
		// *** Begin Get Remote File Size //
		ob_start();
			$chF = curl_init($file);
			curl_setopt($chF, CURLOPT_HEADER, 1);
			curl_setopt($chF, CURLOPT_NOBODY, 1);		 
			$ok = curl_exec($chF);
			curl_close($chF);
			$head = ob_get_contents();
		ob_end_clean();
 
		$regex = '/Content-Length:\s([0-9].+?)\s/';
		$count = preg_match($regex, $head, $matches);
 
		if($matches[1] > 0)
		{
			if (isset($matches))
			{
				$file_size = $matches[1];
				$file_size_kb = round($file_size/1024, 2);
			}
			else
			{
				$no_filesize = true;
				unset($file_size);
			}

			// Check that the remote file is not too big
			if($file_size > $sizelimit && $sizelimit > 0)
			{
				echo '<p>The file size is too large.<br />Max. file size is '.$sizelimit_kb.'KB.</p>';
				$copy_fail = true;
			}
			
 			// *** End Get Remote File Size //
			
			if($copy_fail == false && $file_size > 0)
			{
				//start the html for the progress bar output. this first output is about 1024 bytes or more, 
				// to attempt to override the browser from buffering the following output. $prog->progress("pb-start")
			
				ob_flush();
				flush();
				$fp = fopen($ds, 'w');
				$prog->progress("pb-start");

				// file_put_contents( 'progress.txt', '' );
				 
				$ch = curl_init($file);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
				curl_setopt( $ch, CURLOPT_NOPROGRESS, false );
				curl_setopt( $ch, CURLOPT_PROGRESSFUNCTION, 'progressCallback' );
				curl_setopt( $ch, CURLOPT_FILE, $fp );
				curl_exec( $ch );
				$curl_info = curl_getinfo($ch);
				fclose( $ch );
				fclose($fp);
				$prog->progress("pb-end");		
			}
		}
		else
		{
			if (!copy($file, $ds))
			{
				echo '<p>Unable to import <a href="'.$file.'">'.$file.'</a><br />Check that your file path and destination path are correct.</p>';
				$copy_fail = true;
			}
		}
 
		if ($copy_fail == false)
		{
			if ($sizelimit > 0 && filesize($ds) > $sizelimit)
			{
				echo '<p><strong>The file is too large.</strong>';
				unlink($ds);
			}
			else
			{
				$size_dl = round($curl_info['size_download']/1024, 2);
				$speed_dl = round($curl_info['speed_download']/1024, 2);
				echo '</div><div style="margin-top:30px"><p><strong>Success! - '.$newfilename.'</strong> ('.$size_dl.'KB) was uploaded in '.$curl_info['total_time'].' seconds at '.$speed_dl.'KB/s.</p></div>';
			}
		}
	}
}

} else {
	// Cannot find the Airtime store/organize folder - exiting..
	echo "<p style='color:#ff0000;'><strong>CONFIGURATION ERROR!</strong><br /></p>";
	echo "<p>The specified destination folder <strong>'".$absolute_path_to_storfolder."'</strong> does not exist.</p>";
}
?>
</body>
</html>